Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 666)
+++ /palm/trunk/SOURCE/Makefile	(revision 667)
@@ -4,5 +4,5 @@
 # Current revisions:
 # ------------------
-# 
+# +advec_ws
 #
 # Former revisions:
@@ -57,18 +57,18 @@
 
 RCS = advec_particles.f90 advec_s_bc.f90 advec_s_pw.f90 advec_s_up.f90 \
-	advec_s_ups.f90 advec_u_pw.f90 advec_u_up.f90 advec_u_ups.f90 \
-	advec_v_pw.f90 advec_v_up.f90 advec_v_ups.f90 advec_w_pw.f90 \
-	advec_w_up.f90 advec_w_ups.f90 asselin_filter.f90 average_3d_data.f90 \
-	boundary_conds.f90 buoyancy.f90 calc_liquid_water_content.f90 \
-	calc_precipitation.f90 calc_radiation.f90 calc_spectra.f90 \
-	check_for_restart.f90 check_open.f90 check_parameters.f90 \
-	close_file.f90 compute_vpt.f90 coriolis.f90 cpu_log.f90 \
-	cpu_statistics.f90 data_log.f90 data_output_dvrp.f90 \
-	data_output_mask.f90 data_output_profiles.f90 data_output_ptseries.f90 \
-	data_output_spectra.f90 data_output_tseries.f90 data_output_2d.f90 \
-	data_output_3d.f90 diffusion_e.f90 diffusion_s.f90 diffusion_u.f90 \
-	diffusion_v.f90 diffusion_w.f90 diffusivities.f90 disturb_field.f90 \
-	disturb_heatflux.f90 eqn_state_seawater.f90 exchange_horiz.f90 \
-	exchange_horiz_2d.f90 \
+        advec_ws.f90 advec_s_ups.f90 advec_u_pw.f90 advec_u_up.f90 \
+        advec_u_ups.f90 advec_v_pw.f90 advec_v_up.f90 advec_v_ups.f90 \
+        advec_w_pw.f90 advec_w_up.f90 advec_w_ups.f90 asselin_filter.f90 \
+        average_3d_data.f90 boundary_conds.f90 buoyancy.f90 \
+        calc_liquid_water_content.f90 calc_precipitation.f90 \
+        calc_radiation.f90 calc_spectra.f90 check_for_restart.f90 \
+        check_open.f90 check_parameters.f90 close_file.f90 compute_vpt.f90 \
+        coriolis.f90 cpu_log.f90 cpu_statistics.f90 data_log.f90 \
+        data_output_dvrp.f90 data_output_mask.f90 data_output_profiles.f90 \
+        data_output_ptseries.f90 data_output_spectra.f90 data_output_tseries.f90 \
+        data_output_2d.f90 data_output_3d.f90 diffusion_e.f90 diffusion_s.f90 \
+        diffusion_u.f90 diffusion_v.f90 diffusion_w.f90 diffusivities.f90 \
+        disturb_field.f90 disturb_heatflux.f90 eqn_state_seawater.f90 \
+        exchange_horiz.f90 exchange_horiz_2d.f90 \
 	fft_xy.f90 flow_statistics.f90 global_min_max.f90 \
 	header.f90 impact_of_latent_heat.f90 inflow_turbulence.f90 \
@@ -77,6 +77,6 @@
 	init_masks.f90 init_ocean.f90 init_particles.f90 init_pegrid.f90 \
 	init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
-	interaction_droplets_ptq.f90 local_flush.f90 local_getenv.f90 \
-	local_stop.f90 local_system.f90 local_tremain.f90 \
+	interaction_droplets_ptq.f90 local_flush.f90 \
+        local_getenv.f90 local_stop.f90 local_system.f90 local_tremain.f90 \
 	local_tremain_ini.f90 message.f90 modules.f90 netcdf.f90 \
 	package_parin.f90 palm.f90 parin.f90 particle_boundary_conds.f90 \
@@ -106,5 +106,5 @@
 OBJS =  advec_particles.o advec_s_bc.o advec_s_pw.o advec_s_up.o \
 	advec_s_ups.o advec_u_pw.o advec_u_up.o advec_u_ups.o \
-	advec_v_pw.o advec_v_up.o advec_v_ups.o advec_w_pw.o \
+        advec_ws.o advec_v_pw.o advec_v_up.o advec_v_ups.o advec_w_pw.o \
 	advec_w_up.o advec_w_ups.o asselin_filter.o average_3d_data.o \
 	boundary_conds.o buoyancy.o calc_liquid_water_content.o \
@@ -184,4 +184,5 @@
 advec_v_up.o: modules.o
 advec_v_ups.o: modules.o
+advec_ws.o: modules.o
 advec_w_pw.o: modules.o
 advec_w_up.o: modules.o
@@ -230,5 +231,5 @@
 inflow_turbulence.o: modules.o
 init_1d_model.o: modules.o
-init_3d_model.o: modules.o random_function.o
+init_3d_model.o: modules.o random_function.o advec_ws.o
 init_advec.o: modules.o
 init_cloud_physics.o: modules.o
@@ -264,4 +265,5 @@
 production_e.o: modules.o wall_fluxes.o
 prognostic_equations.o: modules.o advec_s_pw.o advec_s_up.o advec_u_pw.o \
+        advec_ws.o \
 	advec_u_up.o advec_v_pw.o advec_v_up.o advec_w_pw.o advec_w_up.o  \
 	buoyancy.o calc_precipitation.o calc_radiation.o coriolis.o \
Index: /palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- /palm/trunk/SOURCE/advec_particles.f90	(revision 666)
+++ /palm/trunk/SOURCE/advec_particles.f90	(revision 667)
@@ -4,4 +4,6 @@
 ! Current revisions:
 ! -----------------
+! Declaration of de_dx, de_dy, de_dz adapted to additional 
+! ghost points. Furthermore the calls of exchange_horiz were modified.
 ! 
 ! TEST: PRINT statements on unit 9 (commented out)
@@ -153,5 +155,5 @@
     REAL    ::  location(1:30,1:3)
 
-    REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ::  de_dx, de_dy, de_dz
+    REAL, DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  de_dx, de_dy, de_dz
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE ::  trlpt, trnpt, trrpt, trspt
@@ -768,8 +770,8 @@
 !
 !--    Lateral boundary conditions
-       CALL exchange_horiz( de_dx )
-       CALL exchange_horiz( de_dy )
-       CALL exchange_horiz( de_dz )
-       CALL exchange_horiz( diss  )
+       CALL exchange_horiz( de_dx, nbgp )
+       CALL exchange_horiz( de_dy, nbgp )
+       CALL exchange_horiz( de_dz, nbgp )
+       CALL exchange_horiz( diss, nbgp  )
 
 !
Index: /palm/trunk/SOURCE/asselin_filter.f90
===================================================================
--- /palm/trunk/SOURCE/asselin_filter.f90	(revision 666)
+++ /palm/trunk/SOURCE/asselin_filter.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -49,6 +49,6 @@
 !$OMP PARALLEL PRIVATE (i,j,k)
 !$OMP DO
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
 
           DO  k = nzb_2d(j,i), nzt+1
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 666)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -58,6 +58,6 @@
 
           CASE ( 'e' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       e_av(k,j,i) = e_av(k,j,i) / REAL( average_count_3d )
@@ -67,6 +67,6 @@
 
           CASE ( 'qsws*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    qsws_av(j,i) = qsws_av(j,i) / REAL( average_count_3d )
                 ENDDO
@@ -74,6 +74,6 @@
 
           CASE ( 'lwp*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    lwp_av(j,i) = lwp_av(j,i) / REAL( average_count_3d )
                 ENDDO
@@ -81,6 +81,6 @@
 
           CASE ( 'p' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       p_av(k,j,i) = p_av(k,j,i) / REAL( average_count_3d )
@@ -108,6 +108,6 @@
 
           CASE ( 'prr*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    precipitation_rate_av(j,i) = precipitation_rate_av(j,i) / &
                                                 REAL( average_count_3d )
@@ -116,6 +116,6 @@
 
           CASE ( 'pt' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d )
@@ -125,6 +125,6 @@
 
           CASE ( 'q' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d )
@@ -134,6 +134,6 @@
 
           CASE ( 'ql' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       ql_av(k,j,i) = ql_av(k,j,i) / REAL( average_count_3d )
@@ -143,6 +143,6 @@
 
           CASE ( 'ql_c' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       ql_c_av(k,j,i) = ql_c_av(k,j,i) / REAL( average_count_3d )
@@ -152,6 +152,6 @@
 
           CASE ( 'ql_v' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       ql_v_av(k,j,i) = ql_v_av(k,j,i) / REAL( average_count_3d )
@@ -161,6 +161,6 @@
 
           CASE ( 'ql_vp' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       ql_vp_av(k,j,i) = ql_vp_av(k,j,i) / &
@@ -171,6 +171,6 @@
 
           CASE ( 'qv' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       qv_av(k,j,i) = qv_av(k,j,i) / REAL( average_count_3d )
@@ -180,6 +180,6 @@
 
           CASE ( 'rho' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       rho_av(k,j,i) = rho_av(k,j,i) / REAL( average_count_3d )
@@ -189,6 +189,6 @@
 
           CASE ( 's' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       s_av(k,j,i) = s_av(k,j,i) / REAL( average_count_3d )
@@ -198,6 +198,6 @@
 
           CASE ( 'sa' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       sa_av(k,j,i) = sa_av(k,j,i) / REAL( average_count_3d )
@@ -207,6 +207,6 @@
 
          CASE ( 'shf*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    shf_av(j,i) = shf_av(j,i) / REAL( average_count_3d )
                 ENDDO
@@ -214,6 +214,6 @@
 
           CASE ( 't*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    ts_av(j,i) = ts_av(j,i) / REAL( average_count_3d )
                 ENDDO
@@ -221,6 +221,6 @@
 
           CASE ( 'u' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d )
@@ -230,6 +230,6 @@
 
           CASE ( 'u*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    us_av(j,i) = us_av(j,i) / REAL( average_count_3d )
                 ENDDO
@@ -237,6 +237,6 @@
 
           CASE ( 'v' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d )
@@ -246,6 +246,6 @@
 
           CASE ( 'vpt' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       vpt_av(k,j,i) = vpt_av(k,j,i) / REAL( average_count_3d )
@@ -255,6 +255,6 @@
 
           CASE ( 'w' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
                       w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d )
@@ -264,6 +264,6 @@
 
           CASE ( 'z0*' )
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    z0_av(j,i) = z0_av(j,i) / REAL( average_count_3d )
                 ENDDO
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 666)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 667)
@@ -4,6 +4,12 @@
 ! Current revisions:
 ! -----------------
+!
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
+!
 ! 
-!
+! Removed mirror boundary conditions for u and v at the bottom in case of 
+! ibc_uv_b == 0. Instead, dirichelt boundary conditions (u=v=0) are set
+! in init_3d_model 
+!  
 ! Former revisions:
 ! -----------------
@@ -70,17 +76,11 @@
     IF ( range == 'main')  THEN
 !
-!--    Bottom boundary
-       IF ( ibc_uv_b == 0 )  THEN
-!
-!--       Satisfying the Dirichlet condition with an extra layer below the
-!--       surface where the u and v component change their sign
-          u_p(nzb,:,:) = -u_p(nzb+1,:,:)
-          v_p(nzb,:,:) = -v_p(nzb+1,:,:)
-       ELSE
+!--    Bottom boundary 
+       IF ( ibc_uv_b == 1 )  THEN
           u_p(nzb,:,:) = u_p(nzb+1,:,:)
           v_p(nzb,:,:) = v_p(nzb+1,:,:)
        ENDIF
-       DO  i = nxl-1, nxr+1
-          DO  j = nys-1, nyn+1
+       DO  i = nxlg, nxrg
+          DO  j = nysg, nyng
              w_p(nzb_w_inner(j,i),j,i) = 0.0
           ENDDO
@@ -90,9 +90,9 @@
 !--    Top boundary
        IF ( ibc_uv_t == 0 )  THEN
-          u_p(nzt+1,:,:) = ug(nzt+1)
-          v_p(nzt+1,:,:) = vg(nzt+1)
+           u_p(nzt+1,:,:) = ug(nzt+1)
+           v_p(nzt+1,:,:) = vg(nzt+1)
        ELSE
-          u_p(nzt+1,:,:) = u_p(nzt,:,:)
-          v_p(nzt+1,:,:) = v_p(nzt,:,:)
+           u_p(nzt+1,:,:) = u_p(nzt,:,:)
+           v_p(nzt+1,:,:) = v_p(nzt,:,:)
        ENDIF
        w_p(nzt:nzt+1,:,:) = 0.0  ! nzt is not a prognostic level (but cf. pres)
@@ -103,12 +103,12 @@
 !--    the sea surface temperature of the coupled ocean model.
        IF ( ibc_pt_b == 0 )  THEN
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 pt_p(nzb_s_inner(j,i),j,i) = pt(nzb_s_inner(j,i),j,i)
              ENDDO
           ENDDO
        ELSEIF ( ibc_pt_b == 1 )  THEN
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 pt_p(nzb_s_inner(j,i),j,i) = pt_p(nzb_s_inner(j,i)+1,j,i)
              ENDDO
@@ -119,9 +119,9 @@
 !--    Temperature at top boundary
        IF ( ibc_pt_t == 0 )  THEN
-          pt_p(nzt+1,:,:) = pt(nzt+1,:,:)
+           pt_p(nzt+1,:,:) = pt(nzt+1,:,:)
        ELSEIF ( ibc_pt_t == 1 )  THEN
-          pt_p(nzt+1,:,:) = pt_p(nzt,:,:)
+           pt_p(nzt+1,:,:) = pt_p(nzt,:,:)
        ELSEIF ( ibc_pt_t == 2 )  THEN
-          pt_p(nzt+1,:,:) = pt_p(nzt,:,:)   + bc_pt_t_val * dzu(nzt+1)
+           pt_p(nzt+1,:,:) = pt_p(nzt,:,:)   + bc_pt_t_val * dzu(nzt+1)
        ENDIF
 
@@ -130,6 +130,6 @@
 !--    Generally Neumann conditions with de/dz=0 are assumed
        IF ( .NOT. constant_diffusion )  THEN
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 e_p(nzb_s_inner(j,i),j,i) = e_p(nzb_s_inner(j,i)+1,j,i)
              ENDDO
@@ -144,6 +144,6 @@
 !--       Bottom boundary: Neumann condition because salinity flux is always
 !--       given
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 sa_p(nzb_s_inner(j,i),j,i) = sa_p(nzb_s_inner(j,i)+1,j,i)
              ENDDO
@@ -153,7 +153,7 @@
 !--       Top boundary: Dirichlet or Neumann
           IF ( ibc_sa_t == 0 )  THEN
-             sa_p(nzt+1,:,:) = sa(nzt+1,:,:)
+              sa_p(nzt+1,:,:) = sa(nzt+1,:,:)
           ELSEIF ( ibc_sa_t == 1 )  THEN
-             sa_p(nzt+1,:,:) = sa_p(nzt,:,:)
+              sa_p(nzt+1,:,:) = sa_p(nzt,:,:)
           ENDIF
 
@@ -167,12 +167,12 @@
 !--       Surface conditions for constant_humidity_flux
           IF ( ibc_q_b == 0 ) THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    q_p(nzb_s_inner(j,i),j,i) = q(nzb_s_inner(j,i),j,i)
                 ENDDO
              ENDDO
           ELSE
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    q_p(nzb_s_inner(j,i),j,i) = q_p(nzb_s_inner(j,i)+1,j,i)
                 ENDDO
@@ -182,4 +182,6 @@
 !--       Top boundary
           q_p(nzt+1,:,:) = q_p(nzt,:,:)   + bc_q_t_val * dzu(nzt+1)
+
+
        ENDIF
 
@@ -226,5 +228,5 @@
        c_max = dy / dt_3d
 
-       DO i = nxl-1, nxr+1
+       DO i = nxlg, nxrg
           DO k = nzb+1, nzt+1
 
@@ -299,6 +301,6 @@
 !--    Bottom boundary at the outflow
        IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,-1,:) = -u_p(nzb+1,-1,:) 
-          v_p(nzb,0,:)  = -v_p(nzb+1,0,:)  
+          u_p(nzb,-1,:) = 0.0 
+          v_p(nzb,0,:)  = 0.0  
        ELSE                    
           u_p(nzb,-1,:) =  u_p(nzb+1,-1,:)
@@ -324,5 +326,5 @@
        c_max = dy / dt_3d
 
-       DO i = nxl-1, nxr+1
+       DO i = nxlg, nxrg
           DO k = nzb+1, nzt+1
 
@@ -397,6 +399,6 @@
 !--    Bottom boundary at the outflow
        IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,ny+1,:) = -u_p(nzb+1,ny+1,:) 
-          v_p(nzb,ny+1,:) = -v_p(nzb+1,ny+1,:)  
+          u_p(nzb,ny+1,:) = 0.0 
+          v_p(nzb,ny+1,:) = 0.0   
        ELSE                    
           u_p(nzb,ny+1,:) =  u_p(nzb+1,ny+1,:)
@@ -422,5 +424,5 @@
        c_max = dx / dt_3d
 
-       DO j = nys-1, nyn+1
+       DO j = nysg, nyng
           DO k = nzb+1, nzt+1
 
@@ -495,8 +497,8 @@
 !--    Bottom boundary at the outflow
        IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,:,-1) = -u_p(nzb+1,:,-1) 
-          v_p(nzb,:,-1) = -v_p(nzb+1,:,-1)  
+          u_p(nzb,:,0)  = 0.0 
+          v_p(nzb,:,-1) = 0.0
        ELSE                    
-          u_p(nzb,:,-1) =  u_p(nzb+1,:,-1)
+          u_p(nzb,:,0)  =  u_p(nzb+1,:,0)
           v_p(nzb,:,-1) =  v_p(nzb+1,:,-1)
        ENDIF
@@ -520,5 +522,5 @@
        c_max = dx / dt_3d
 
-       DO j = nys-1, nyn+1
+       DO j = nysg, nyng
           DO k = nzb+1, nzt+1
 
@@ -593,6 +595,6 @@
 !--    Bottom boundary at the outflow
        IF ( ibc_uv_b == 0 )  THEN
-          u_p(nzb,:,nx+1) = -u_p(nzb+1,:,nx+1) 
-          v_p(nzb,:,nx+1) = -v_p(nzb+1,:,nx+1)  
+          u_p(nzb,:,nx+1) = 0.0
+          v_p(nzb,:,nx+1) = 0.0 
        ELSE                    
           u_p(nzb,:,nx+1) =  u_p(nzb+1,:,nx+1)
Index: /palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 666)
+++ /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
 !
 ! Former revisions:
@@ -47,6 +47,6 @@
     REAL :: alpha, e_s, q_s, t_l
 
-    DO  i = nxl-1, nxr+1
-       DO  j = nys-1, nyn+1
+    DO  i = nxlg, nxrg
+       DO  j = nysg, nyng
           DO  k = nzb_2d(j,i)+1, nzt
 
Index: /palm/trunk/SOURCE/calc_precipitation.f90
===================================================================
--- /palm/trunk/SOURCE/calc_precipitation.f90	(revision 666)
+++ /palm/trunk/SOURCE/calc_precipitation.f90	(revision 667)
@@ -8,5 +8,5 @@
 ! Former revisions:
 ! -----------------
-! $Id$
+! $Id: calc_precipitation.f90 484 2010-02-05 07:36:54Z raasch 
 !
 ! 403 2009-10-22 13:57:16Z franke
Index: /palm/trunk/SOURCE/calc_spectra.f90
===================================================================
--- /palm/trunk/SOURCE/calc_spectra.f90	(revision 666)
+++ /palm/trunk/SOURCE/calc_spectra.f90	(revision 667)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng for allocation
+! of tend
 !
 ! Former revisions:
@@ -152,5 +153,5 @@
     IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
        DEALLOCATE( tend )
-       ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ENDIF
 
Index: /palm/trunk/SOURCE/check_for_restart.f90
===================================================================
--- /palm/trunk/SOURCE/check_for_restart.f90	(revision 666)
+++ /palm/trunk/SOURCE/check_for_restart.f90	(revision 667)
@@ -5,4 +5,5 @@
 ! -----------------
 ! 
+! Exchange of terminate_coupled between ocean and atmosphere by PE0
 !
 ! Former revisions:
@@ -93,9 +94,12 @@
        terminate_coupled = 3
 #if defined( __parallel )
-       CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,          &
-                          target_id, 0,                                      &
-                          terminate_coupled_remote, 1, MPI_INTEGER,          &
-                          target_id, 0,                                      &
-                          comm_inter, status, ierr )
+       IF ( myid == 0 ) THEN
+          CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,          &
+                             target_id, 0,                                      &
+                             terminate_coupled_remote, 1, MPI_INTEGER,          &
+                             target_id, 0,                                      &
+                             comm_inter, status, ierr )
+       ENDIF
+       CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr)
 #endif
     ENDIF
@@ -140,9 +144,13 @@
              ENDIF
 #if defined( __parallel )
-             CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,    &
-                                target_id,  0,                               &
-                                terminate_coupled_remote, 1, MPI_INTEGER,    &
-                                target_id,  0,                               &
-                                comm_inter, status, ierr )
+             IF ( myid == 0 ) THEN
+                CALL MPI_SENDRECV( terminate_coupled,        1, MPI_INTEGER,    &
+                                   target_id,  0,                               &
+                                   terminate_coupled_remote, 1, MPI_INTEGER,    &
+                                   target_id,  0,                               &
+                                   comm_inter, status, ierr )   
+             ENDIF
+             CALL MPI_BCAST( terminate_coupled_remote, 1, MPI_INTEGER, 0, comm2d, ierr)  
+            
 #endif
           ENDIF
Index: /palm/trunk/SOURCE/check_open.f90
===================================================================
--- /palm/trunk/SOURCE/check_open.f90	(revision 666)
+++ /palm/trunk/SOURCE/check_open.f90	(revision 667)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of total array size was adapted to nbgp.
 !
 ! Former revisions:
@@ -278,5 +278,5 @@
 !--          Output for combine_plot_fields
              IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (21)  -1, nx+1, -1, ny+1    ! total array size
+                WRITE (21)  -nbgp, nx+nbgp, -nbgp, ny+nbgp    ! total array size
                 WRITE (21)   0, nx+1,  0, ny+1    ! output part
              ENDIF
@@ -319,5 +319,5 @@
 !--          Output for combine_plot_fields
              IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (22)  -1, nx+1, 0, nz+1    ! total array size
+                WRITE (22)  -nbgp, nx+nbgp, 0, nz+1    ! total array size
                 WRITE (22)   0, nx+1, 0, nz+1    ! output part
              ENDIF
@@ -357,5 +357,5 @@
 !--          Output for combine_plot_fields
              IF ( data_output_2d_on_each_pe  .AND.  myid_char /= '' )  THEN
-                WRITE (23)  -1, ny+1, 0, nz+1    ! total array size
+                WRITE (23)  -nbgp, ny+nbgp, 0, nz+1    ! total array size
                 WRITE (23)   0, ny+1, 0, nz+1    ! output part
              ENDIF
@@ -392,5 +392,5 @@
 !--          Specifications for combine_plot_fields
              IF ( .NOT. do3d_compress )  THEN
-                WRITE ( 30 )  -1,nx+1,-1,ny+1,0,nz_do3d
+                WRITE ( 30 )  -nbgp,nx+nbgp,-nbgp,ny+nbgp, 0 ,nz_do3d
                 WRITE ( 30 )  0,nx+1,0,ny+1,0,nz_do3d
              ENDIF
@@ -503,6 +503,6 @@
                 openfile(33)%opened = .TRUE.
                 WRITE ( 33, 3300 )  TRIM( avs_coor_file ), &
-                                    TRIM( avs_coor_file ), (nx+2)*4, &
-                                    TRIM( avs_coor_file ), (nx+2)*4+(ny+2)*4
+                                    TRIM( avs_coor_file ), (nx+2*nbgp)*4, &
+                                    TRIM( avs_coor_file ), (nx+2*nbgp)*4+(ny+2*nbgp)*4
             
 
@@ -548,5 +548,5 @@
 !--       corresponding partial array of a PE only once at the top of the file
           IF ( avs_output  .AND.  do3d_compress )  THEN
-             WRITE ( 30 )  nxl-1, nxr+1, nys-1, nyn+1, nzb, nz_do3d
+             WRITE ( 30 )  nxlg, nxrg, nysg, nyng, nzb, nz_do3d
           ENDIF
 
@@ -929,5 +929,5 @@
 #endif
              ENDIF
-
+             
              CALL handle_netcdf_error( 'check_open', 26 )
 !
@@ -1325,5 +1325,5 @@
 #endif
              ENDIF
-
+             
              CALL handle_netcdf_error( 'check_open', 43 )  
 
